routes/web.php
<?php
use App\Models\Categories;

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Homepage\WeaponController;
use App\Http\Controllers\Homepage\DirectController;
use App\Http\Controllers\Homepage\CartsController;
use App\Http\Controllers\Homepage\Details\PistolController;

// admin
use App\Http\Controllers\Admin\Homepage\AdminHomeController;
use App\Http\Controllers\Admin\Homepage\SubcategoriesController;
use App\Http\Controllers\Admin\Homepage\CategoriesController;
use App\Http\Controllers\Admin\Homepage\InventoriesController;
use App\Http\Controllers\Admin\Homepage\BucketController;
use App\Http\Controllers\Admin\Homepage\UsersController;
use App\Http\Controllers\Admin\DatatablesController;
use App\Http\Controllers\HomeController;

// Livewire





/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    $categories = Categories::all();
   
    return view('welcome', compact('categories'));
})->name('welcome');


Route::resource('admin/bucket', BucketController::class);

Route::resource('/carts', CartsController::class);

Route::get('admin/users/data', [DatatablesController::class, 'dataUsers'])->name('users.data');
Route::resource('admin/users', UsersController::class);
Route::get('admin/inventories/data', [DatatablesController::class, 'dataInventories'])->name('inventories.data');
Route::resource('admin/inventories', InventoriesController::class);
Route::get('admin/sub-categories/data', [DatatablesController::class, 'dataSubcategories'])->name('subcategories.data');
Route::resource('admin/sub-categories', SubcategoriesController::class);
Route::get('admin/categories/data', [DatatablesController::class, 'dataCategories'])->name('categories.data');
Route::resource('admin/categories', CategoriesController::class);
Route::resource('admin', AdminHomeController::class);

Route::resource('/weapon/pistol', PistolController::class);
Route::resource('/weapon', WeaponController::class);

Auth::routes(['verify' => true]);

Route::get('order-list/code/{id}', [HomeController::class, 'modalDataHistori'])->name('order.modal');
Route::get('order-list/data', [HomeController::class, 'dataHistori'])->name('order.data');
Route::get('order-list', [HomeController::class, 'historical'])->name('order');

Route::put('bucket/unconfirm/{id}', [HomeController::class, 'unconfirmBucket'])->name('unconfirmBucket');
Route::put('bucket/confirm/{id}', [HomeController::class, 'confirmBucket'])->name('confirmBucket');

Route::get('carts/period/update/{id}', [HomeController::class, 'updateTriggerDuration'])->name('updateTriggerDuration');
Route::get('carts/period/modal/{id}', [HomeController::class, 'triggerDuration'])->name('triggerDuration');
Route::get('carts/modals/{id}', [HomeController::class, 'updateTriggerModal'])->name('updateTriggerModal');
Route::get('carts/modal/{id}', [HomeController::class, 'triggerModalCart'])->name('triggerModalCart');
Route::get('home', [HomeController::class, 'index'])->name('home');

Route::get('details/{id}', [DirectController::class, 'details'])->name('details.items');
Route::get('item/{id}', [DirectController::class, 'directDetails'])->name('directDetails');
Route::get('category/{id}', [DirectController::class, 'directItemInventory'])->name('directItemsInventory');
Route::get('directInventory/{id}', [DirectController::class, 'directInventory'])->name('directInventory');
Route::get('{id}', [DirectController::class, 'directSubcategoriesWeapons'])->name('directSubCategories');
Route::get('directHomepage/{id}', [DirectController::class, 'directHomepage'])->name('directHomepage');

app/Http/Controllers/Admin/Homepage/AdminHomeController.php
<?php

namespace App\Http\Controllers\Admin\Homepage;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use RealRashid\SweetAlert\Facades\Alert;

class AdminHomeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function __construct()
    {
        $this->middleware(['auth', 'verified', 'role:admin']);
    }

    public function index()
    {   
        Alert::alert('Welcome '. Auth::user()->name, 'Have a nice day !', 'Type');

        return view('admin.homepage.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        dd($id);
    }
}

app/Http/Controllers/Admin/Homepage/BucketController.php
<?php

namespace App\Http\Controllers\Admin\Homepage;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use App\Models\User;
use App\Models\Cart;
use App\Models\Bucket;
use App\Models\Inventory;
use Illuminate\Support\Facades\Mail;
use App\Mail\InvoiceMail;

class BucketController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function __construct()
    {
        $this->middleware(['auth', 'verified', 'role:admin']);
    }

    public function index()
    {
       $title = 'Admin - Carts';
       $buckets = Bucket::with('users')->where('statusBooking', 0)->get();     

       return view('admin.homepage.carts', compact(['title', 'buckets']));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
    
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $title = 'Admin - Check Carts';
        $carts = Cart::with(['categories', 'subcategories', 'inventories'])->where('kodeBooking', $id)->where('status', 1)->where('statSuccess', 0)->get();
        $users = Cart::with('users')->where('kodeBooking', $id)->first();
        $no = 1;

        return view('admin.homepage.bucket.show', compact(['title', 'carts', 'users', 'no']));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        Bucket::where('kodeBooking', $id)->update([
            'statusBooking' => 1,
        ]);      

        $bucket = Bucket::with(['users'])->where('kodeBooking', $id)->where('statusBooking', 1)->first();

        $carts = Cart::where('kodeBooking', $bucket->kodeBooking)->where('checkbox', 1)->get();

        foreach ($carts as $cart) {
          Inventory::where('id', $cart->inventories_id)->update([
              'users_id' => $cart->users_id,
              'status' => 'Unavailable'
          ]);

          Cart::where('id', $cart->id)->update([
              'statSuccess' => 1,
          ]);
        }

        Mail::to($bucket->users->email)->send(new InvoiceMail($bucket));

        toast('Cconfirmed item has been delivered successfully','success');

        return redirect()->route('bucket.index');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Admin/Homepage/CategoriesController.php
<?php

namespace App\Http\Controllers\Admin\Homepage;

use App\Http\Controllers\Controller;

use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;

use App\Models\Categories;

use Intervention\Image\ImageManager;
use RealRashid\SweetAlert\Facades\Alert;
use Illuminate\Support\Facades\Storage;

class CategoriesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function __construct()
    {
        $this->middleware(['auth', 'verified', 'role:admin']);
    }
    
    public function index()
    {
        $title = 'Admin - Category';
        return view('admin.homepage.categories', compact(['title']));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $title = 'Admin - Add Category';
        return view('admin.homepage.categories.addCategories', compact('title'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {        
        $validator = Validator::make($request->all(), [
            'category' => 'required|unique:posts|string|max:255',
            'picture' => 'required|file|image|mimes:jpeg,png,jpg|max:2048',
        ]);
        
        $cover = null;

        if ($request->hasFile('picture')) {
            $cover =  $request->file('picture')->store('public/assets/parent_categories'); 
        }     

        Categories::create([
            'name_categories' => $request->category,
            'imageCategories' => $cover
        ]);
        toast('Parent Category '.$request->category.' has been created !!','success');        

        return redirect()->route('categories.index');

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
       
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {       
        $data = Categories::where('name_categories', $id)->first();
        $title = 'Admin - Edit Category';
        return view('admin.homepage.categories.editCategories', compact(['data', 'title']));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $category = Categories::findOrFail($id);

        $validator = Validator::make($request->all(), [
            'category' => 'required|unique:posts|string|min:3',
            'picture' => 'required|file|image|mimes:jpeg,png,jpg|max:2048',
        ]);

        $cover = null;
     
        if ($request->picture === null) {

            $cover = $category->imageCategories;

        } else {
           
            if ($request->hasFile('picture')) {
                if ($category->imageCategories != 'https://picsum.photos/200') {
                    Storage::delete($category->imageCategories);
                }
                $cover =  $request->file('picture')->store('public/assets/parent_categories'); 
            }  
        }

        Categories::where('id', $category->id)->update([
            'name_categories' => $request->category,
            'imageCategories' => $cover
        ]);

        toast('Parent Category '.$category->name_categories.' has been updated !!','info');

        return redirect()->route('categories.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {   
        $data = Categories::where('name_categories', $id)->first();   
        Storage::delete($category->imageCategories);
        $category->delete();       

        return redirect()->route('categories.index');
    }
}

app/Http/Controllers/Admin/Homepage/SubcategoriesController.php
<?php

namespace App\Http\Controllers\Admin\Homepage;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Subcategories;
use App\Models\Categories;
use RealRashid\SweetAlert\Facades\Alert;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Validator;

class SubcategoriesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function __construct()
    {
        $this->middleware(['auth', 'verified', 'role:admin']);
    }

    public function index()
    {
        $title = 'Admin - Sub Category';
       
        return view('admin.homepage.subcategories', compact(['title']));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $title = 'Admin - Add Sub Category';
        $categories = Categories::all();

        return view('admin.homepage.subcategories.addSubcategories', compact(['title', 'categories']));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'category'      => 'required',
            'subcategory'   => 'required|unique:post|max:255',
            'picture' => 'required|file|image|mimes:jpeg,png,jpg|max:2048',
        ]);
        
        $cover = null;

        if ($request->hasFile('picture')) {
            $cover =  $request->file('picture')->store('public/assets/sub_categories'); 
        }     

        Subcategories::create([
            'categories_id'   => $request->category,
            'name_subcategories' => $request->subcategory,
            'imageSubcategories' => $cover
        ]);
        toast('Sub Category '.$request->subcategory.' has been created !!','success');        

        return redirect()->route('sub-categories.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $subcategories = Subcategories::where('name_subcategories', $id)->first();
        $categories = Categories::all();
        $title = "Admin - Edit Sub Category";

        return view('admin.homepage.subcategories.editSubcategories', compact(['title', 'subcategories', 'categories']));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $subcategories = Subcategories::findOrFail($id);

        $validator = Validator::make($request->all(), [
            'category'      => 'required',
            'subcategory'   => 'required|unique:post|max:255',
            'picture'       => 'required|file|image|mimes:jpeg,png,jpg|max:2048',
        ]);

        if ($request->picture === null) {
            $cover = null;
        } else {
            $cover = $subcategories->imageSubcategories;
        }

        if ($request->hasFile('picture')) {
            Storage::delete($subcategories->imageSubcategories);
            $cover =  $request->file('picture')->store('public/assets/sub_categories'); 
        }     

        Subcategories::where('id', $id)->update([
            'categories_id'   => $request->category,
            'name_subcategories' => $request->subcategory,
            'imageSubcategories' => $cover
        ]);
        toast('Sub Category '.$request->subcategory.' has been Updated !!','success');        

        return redirect()->route('sub-categories.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
       
        $subcategories = Subcategories::where('name_subcategories', $id)->first();
        Storage::delete($subcategories->imageSubcategories);
        $subcategories->delete();

        return redirect()->route('sub-categories.index');
    }
}

resources/views/admin/homepage/categories/action.blade.php
<a href="{{ route('categories.edit', $model) }}" class="btn btn-xs btn-warning" data-toggle="tooltip" data-placement="left" title="Edit"><i class='far fa-edit'></i></a>
<button href="{{ route('categories.destroy', $model) }}" class="btn btn-xs btn-danger" id="delete" data-toggle="tooltip" data-placement="right" title="Delete"><i class='fas fa-trash-alt'></i></button>

<link href="//cdn.jsdelivr.net/npm/@sweetalert2/theme-dark@3/dark.css" rel="stylesheet">
<script src="//cdn.jsdelivr.net/npm/sweetalert2@9/dist/sweetalert2.min.js"></script>

<script src="https://cdn.jsdelivr.net/npm/sweetalert2@8"></script>
<script>
	$(function () {
		$('[data-toggle="tooltip"]').tooltip()
	});

    $('button#delete').on('click', function(e){
        e.preventDefault();
        var href = $(this).attr('href');

        const swalWithBootstrapButtons = Swal.mixin({
		  customClass: {
		    confirmButton: 'btn btn-sm btn-success',
		    cancelButton: 'btn btn-sm btn-danger'
		  },
		  buttonsStyling: false
		});

		Swal.fire({
		  title: 'Are u sure?',		   	  
		  text: "You will not be able to return it!",
		  icon: 'warning',		  
		  showCancelButton: true,
		  confirmButtonText: 'Yes, do it!',
		  cancelButtonText: 'No, don\'t it!', 
		}).then((result) => {
		  if (result.value) {
		  	document.getElementById('deleteForm').action = href;
            document.getElementById('deleteForm').submit();

		    swalWithBootstrapButtons.fire(
		      'Done!',
		      'Data was successfully deleted from the system.',
		      'success'
		    )
		  } else if (
		    result.dismiss === Swal.DismissReason.cancel
		  ) {
		    swalWithBootstrapButtons.fire(
		      'Canceled',
		      'Data successfully secured :)',
		      'error'
		    )
		  }
		});        
    });
</script>

resources/views/admin/homepage/categories/addCategories.blade.php
@extends('admin.layouts.default')

@section('content')

<div class="row">
    <div class="col-sm-8">
        <form class="needs-validation" novalidate method="post" action="{{ route('categories.store') }}" enctype="multipart/form-data">
            @csrf
            <div class="form-row">
              <div class="col-sm-4 mb-3">
                <label for="category">Parent Category</label>
                <input type="text" class="form-control" id="category" placeholder="Category" autocomplete required minlength="3" name="category" value="{{ old('category') }}">
                <div class="valid-feedback">
                  word validation success!
                </div>
              </div>
            </div>
           
            <div class="form-row">
                <div class="col-sm-8 mb-3">
                    <div class="custom-file">
                      <img >
                        <label class="form-label" for="picture">Image for Parent Category <sup>(max: 2mb) (format: jpeg | png | jpg)</sup></label>
                        <br>
                        <img class="img-preview img-fluid" width="250px" height="250px" alt=""> 
                        <input type="file" class="form-control" id="picture" autocomplete required minlength="5" name="picture" value="{{ old('picture') }}" onchange="previewImage()"/>
                    </div>
                    <div class="valid-feedback">
                        image validation success!
                    </div>                  
                </div>
              </div>
            <button class="btn btn-sm btn-outline-primary" type="submit">Add Parent Category</button>
            <a href="{{ route('categories.index') }}" class="btn btn-sm btn-outline-secondary">Back Table Category</a>
          </form>
          
          <script>
          // Example starter JavaScript for disabling form submissions if there are invalid fields
         
          </script>
    </div>    
</div>   
@endsection

@push('scripts')
<script>

function previewImage() {
  const image = document.querySelector('#picture');
  const imgPreview = document.querySelector('.img-preview');

  const oFReader = new FileReader();
  oFReader.readAsDataURL(image.files[0]);

  oFReader.onload = function(oFREvent) {
    imgPreview.src = oFREvent.target.result;
  }
  
}

(function() {
            'use strict';
            window.addEventListener('load', function() {
              // Fetch all the forms we want to apply custom Bootstrap validation styles to
              var forms = document.getElementsByClassName('needs-validation');
              // Loop over them and prevent submission
              var validation = Array.prototype.filter.call(forms, function(form) {
                form.addEventListener('submit', function(event) {
                  if (form.checkValidity() === false) {
                    event.preventDefault();
                    event.stopPropagation();
                  }
                  form.classList.add('was-validated');
                }, false);
              });
            }, false);
          })();

</script>
@endpush

resources/views/admin/homepage/categories/editCategories.blade.php
@extends('admin.layouts.default')

@section('content')

<div class="row">
    <div class="col-sm-8">
        <form class="needs-validation" novalidate method="post" action="{{ route('categories.update', $data->id) }}" enctype="multipart/form-data">          
            @csrf
            @method('put')
            <div class="form-row">
              <div class="col-sm-4 mb-3">
                <label for="category">Parent Category</label>
                <input type="text" class="form-control" id="category" placeholder="Category" autocomplete required minlength="3" name="category" value="{{ old('category') ?? $data->name_categories }}">
                <div class="valid-feedback">
                  word validation success!
                </div>
              </div>
            </div>
            <div class="form-row">
                <div class="col-sm-8 mb-3">
                    <label for="old_picture">Old Image</label>
                    <br>
                    <img src="{{$data->getCoverParentCategories() }}" alt="old Picture" class="img-fluid" width="150px" height="150px;" id="old_picture">
                </div>
              </div>
            <div class="form-row">
                <div class="col-sm-8 mb-3">
                    <div class="custom-file">
                        <label class="form-label" for="picture">Change New Image <sup>(max: 2mb) (format: jpeg | png | jpg)</sup>
                            <br>
                            <small>Note: <i class="text-red">*</i><span> old image will be deleted</span></small>
                        </label>
                        <br>
                        <img class="img-preview img-fluid" width="250px" height="250px" alt=""> 
                        <input type="file" class="form-control" id="picture" autocomplete name="picture" value="{{ old('picture') ?? $data->imageCategories }}" onchange="previewImage()"/>
                    </div>
                    <div class="valid-feedback">
                        image validation success!
                    </div>
                </div>
              </div>
              <div class="form-row">
                <div class="col-sm-8 mb-3">
                   <p>this data is update: <b>{{ $data->updated_at }} WIB</b></p>
                </div>
              </div>
            <button class="btn btn-sm btn-outline-primary" type="submit">Update Parent Category</button>
            <a href="{{ route('categories.index') }}" class="btn btn-sm btn-outline-secondary">Back Table Category</a>
          </form>          
    </div>    
</div>   
@endsection

@push('scripts')
<script>
  function previewImage() {
  const image = document.querySelector('#picture');
  const imgPreview = document.querySelector('.img-preview');

  const oFReader = new FileReader();
  oFReader.readAsDataURL(image.files[0]);

  oFReader.onload = function(oFREvent) {
    imgPreview.src = oFREvent.target.result;
  }
  
}

(function() {
            'use strict';
            window.addEventListener('load', function() {
              // Fetch all the forms we want to apply custom Bootstrap validation styles to
              var forms = document.getElementsByClassName('needs-validation');
              // Loop over them and prevent submission
              var validation = Array.prototype.filter.call(forms, function(form) {
                form.addEventListener('submit', function(event) {
                  if (form.checkValidity() === false) {
                    event.preventDefault();
                    event.stopPropagation();
                  }
                  form.classList.add('was-validated');
                }, false);
              });
            }, false);
          })();


</script>    
@endpush